<?php

ini_set('display_errors', 1);
// error_reporting(0);

require_once '../../../resources/base_path_include.php';
require_once $base_path_to_resources . "includes/config.php";
require_once $base_path_to_resources . 'lib/function.php';

require_once  $base_path_to_resources . 'includes/config.php';
require_once  $base_path_to_resources . 'lib/function.php';
require_once $base_path_to_resources . "lib/currency_functions.php";
require_once $base_path_to_resources . 'lib/validate_function.php';
require_once $base_path_to_resources . 'lib/validate_api_signature.php';

//authentication valdation file
require_once $base_path . 'user_management/authenticate.php';

//valdation file
require_once $base_path . 'modules/accounting/groups_ledgers/functions/ledger_functions.php';
require_once $base_path . 'modules/accounting/groups_ledgers/functions/view_month_ledger_functions.php';
require_once $base_path . 'modules/accounting/book_management/basic_book_info_function.php';
require_once $base_path . 'modules/accounting/functions/basic_balance_function.php';

//creating dynamic db
require_once $base_path_to_resources . 'includes/specific_db_config.php';


$postdata = json_decode(file_get_contents("php://input"), true);
checkIfNoPhpContentsReceive();

if (!isset($postdata['ledgerid']) or !checkIfIssetAndNotEmpty($postdata['ledgerid']) or !isset($postdata['company_id']) or !checkIfIssetAndNotEmpty($postdata['company_id']) or
!isset($postdata['branch_id']) or !checkIfIssetAndNotEmpty($postdata['branch_id']) or  !isset($postdata['book_id']) or !checkIfIssetAndNotEmpty($postdata['book_id']) or !isset($postdata['api_signature']) or !checkIfIssetAndNotEmpty($postdata['api_signature']) or
!isset($postdata['function_type']) or !checkIfIssetAndNotEmpty($postdata['function_type']) or !isset($postdata['jwt_token']) or !checkIfIssetAndNotEmpty($postdata['jwt_token'])) {
    errorreturn("All fields are required.");
}


validateApiSignature($postdata['api_signature']);

//authenticate jwt token
$jwttoken = $postdata['jwt_token'];
$jwt_validate = authenticate_jwt($jwttoken);
//then workspace_id is decoded in data of jwt use from there
$userid = $jwt_validate->data->id;
$workspace_id = $jwt_validate->data->workspace_id;
//print_r($workspace_id);die();

$role = $jwt_validate->data->role;
$username = $jwt_validate->data->username;

$function_type = $postdata['function_type'];

if ($function_type  == "view_ledger_monthly") {

    $company_id = trim($postdata['company_id']);
    $branch_id = trim($postdata['branch_id']);
    $book_id = trim($postdata['book_id']);
    $ledgerid = trim($postdata['ledgerid']);
    $export_type = (isset($postdata['export_type']) and !empty($postdata['export_type'])) ? trim($postdata['export_type']) : null;

     $function_code = 'fetch_ledgers';
     $confirmed_role_user = validatePrimaryAccess($conn, $workspace_id, $role, $userid, ['superadmin', 'admin', null]);
    if (!$confirmed_role_user){ 
        errorreturn('Access denied.');
    }else{
        $specific_db_conn = dynamicDbConnection($confirmed_role_user);
         if ($role == null) {
            checkCompanyBranchFunctionAccess($specific_db_conn, $role, $userid, $workspace_id, $company_id, $branch_id, $book_id,  $function_code);
         }
    }


    $book_info = GetBasicBook($specific_db_conn, $workspace_id, $company_id, $branch_id, $book_id);
    $book_name = $book_info['book_basic_info']['book_name'];
    $book_opening_date = $book_info['book_basic_info']['book_opening_date'];
    $book_closing_date = $book_info['book_basic_info']['book_closing_date'];
   


    if (isset($postdata['mindate']) and !empty($postdata['mindate'])) {
        $mindate = trim($postdata['mindate']);
    } else {
        $mindate = $book_opening_date;
    }

    if (isset($postdata['maxdate']) and !empty($postdata['maxdate'])) {
        $maxdate = trim($postdata['maxdate']);
    } else {
        $maxdate = $book_closing_date;
    }



    if (!strtotime($mindate) or $mindate < $book_opening_date) {
        // echo $mindate,$book_opening_date;die();
        errorreturn('Mininum date cannot be less than book opening date');
    }

    if (!strtotime($maxdate) or $maxdate > $book_closing_date) {

        errorreturn('Maximum date cannot be less than book opening date');
    }
    if ($maxdate < $mindate) {

        errorreturn('Invalid Date format');
    }

    $additionaldata = array();
    $additionaldata = ['month', 'debit_total', 'credit_total', 'month_closing'];


    $limit = '12';
    $page = (isset($postdata['page']) and isNumeric($postdata['page'])) ? (int)$postdata['page'] : 1;
    $offset = ($page - 1) * $limit;
    $search_string = null;


    if (isset($export_type)) { // true // value check should either be spreadsheet pdf 
         if ($export_type == 'spreadsheet') {

             require_once $base_path . 'modules/accounting/groups_ledgers/export/view_ledger_monthly/excel/export_view_ledger_monthly_excel.php';
        } else  if ($export_type == 'pdf') {

        require_once $base_path . 'modules/accounting/groups_ledgers/export/view_ledger_monthly/pdf/export_view_ledger_monthly_pdf.php';
           
        }
        else  if ($export_type == 'print') {

        require_once $base_path . 'modules/accounting/groups_ledgers/export/view_ledger_monthly/print/export_view_ledger_monthly_print.php';
           
        }
    } else {


        $additionaldata = array();
        $additionaldata = ['ledger_opening_bal', 'ledger_parent_group'];

        $ledger_detail = GetBasicLedgerDetail($specific_db_conn, $ledgerid, $workspace_id, $company_id, $branch_id, $book_id, $additionaldata);
        $ledger_opening_bal = $ledger_detail[0]['ledger_opening_bal'];

        $success['data'] = viewLedgerMonthly($specific_db_conn, $ledgerid, $workspace_id, $company_id, $branch_id, $book_id, $ledger_opening_bal, $mindate, $maxdate, $book_opening_date);
        successreturn($success);
    }
}
